import { ViewBase } from '../../libappbase/viewbase';
import { AppMP } from '../appmp';
import { ButtonCapacitiesContextMenuItem } from '../actionbarpages/abp.data';
import { FormTimeCapacities } from '../forms/form.timecapacities';
import { FormShiftPattern } from '../forms/form.shiftpattern';
import { UIWaitSOP } from '../../libappsop/objectsop';

/**
 * Data > Capacities > Time view.
 */
export class ViewCapacitiesTime extends ViewBase implements UIWaitSOP {
  public readonly name = 'Time Capacities';
  public readonly viewPath = 'Data > Capacities > Time';

  public formTimeCapacities = new FormTimeCapacities();
  public formShiftPattern = new FormShiftPattern();

  /**
   * Switch to Time Capacities view
   */
  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    await appMP.abpData.isVisible();
    await appMP.abpData.click();
    await appMP.abpData.btnCapacities.clickDropdownAndSelectMenu(ButtonCapacitiesContextMenuItem.Time.Name);

    // Wait until form present
    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    await this.formTimeCapacities.waitUntilPresent();
    await this.formShiftPattern.waitUntilPresent();
  }
}
